var xeraws = (function ($) {
	var xsrf_token = "";

	var endpoint_base = "";
	//var endpoint_base = "http://localhost:8000/fakews";

	var endpoints = {
		register_account: endpoint_base + "/avene-api/user/register",
		remote_connection: endpoint_base + "/avene-api/user/login",
		post_comment: endpoint_base + "/avene-api/comment",
		get_comments: endpoint_base + "/avene-api/get-comments",
		xeracalm_optin: endpoint_base + "/avene-api/xeracalm-optin",
		token_a_la_con: endpoint_base + "/avene-api/user/token",
		is_logged_in: endpoint_base + "/avene-api/system/connect",
	};

	function is_logged_in() {
		var jq_ajax_promise = _issueRequest(endpoints.token_a_la_con, {});
		jq_ajax_promise.done(function (data, textStatus, jqXHR) {
			xsrf_token = data.token;
		});


		var jq_ajax_promise = _issueRequest(endpoints.is_logged_in, {});

		var result = { success: false, data: "" };

		jq_ajax_promise.done(function (data, textStatus, jqXHR) {
			result.success = true;
			result.data = data;
		})
		.fail(function (jqXHR, textStatus) {
			result.success = false;
			result.data = textStatus;
		});

		return result;
	}

	function remote_connection(remote_connection_struct) {
		var jq_ajax_promise = _issueRequest(endpoints.remote_connection, remote_connection_struct.getData());

		var result = { success: false, data: "" };

		jq_ajax_promise.done(function (data, textStatus, jqXHR) {

			if (data.token) {
				xsrf_token = data.token;
				//xsrf_token = jqXHR.getResponseHeader("X-CSRF-TOKEN");
			}
			result.success = true;
			result.data = data;
		})
		.fail(function (jqXHR, textStatus) {
			if(406 == jqXHR.status){
				console.log(jqXHR, textStatus);
			} else {
				result.success = false;
				result.data = textStatus;
			}
		});

		return result;
	}

	function register_account(register_account_struct) {
		var jq_ajax_promise = _issueRequest(endpoints.register_account, register_account_struct.getData());

		var result = { success: false, data: "" };

		jq_ajax_promise.done(function (data, textStatus, jqXHR) {
			result.success = true;
			result.data = data;
		})
		.fail(function (jqXHR, textStatus) {
			result.success = false;
			result.data = textStatus;
		});

		return result;
	};

	var post_comment = function post_comment(post_comment_struct) {
		var jq_ajax_promise = _issueRequest(endpoints.post_comment, post_comment_struct.getData());

		var result = { success: false, data: "" };

		jq_ajax_promise.done(function (data, textStatus, jqXHR) {
			result.success = true;
			result.data = data;
		})
		.fail(function (jqXHR, textStatus) {
			result.success = false;
			result.data = textStatus;
		});

		return result;
	};

	var get_comments = function get_comments(get_comment_struct, success_cb, fail_cb) {
		var success_cb = success_cb || $.noop;
		var fail_cb = fail_cb || $.noop;

		var ajax_promise = _issueRequest(endpoints.get_comments, get_comment_struct.getData(), true);

		ajax_promise.done(success_cb).fail(fail_cb);
	};

	var xeracalm_optin = function xeracalm_optin(xeracalm_optin_struct) {
		var jq_ajax_promise = _issueRequest(endpoints.xeracalm_optin, xeracalm_optin_struct.getData());

		var result = { success: false, data: "" };
		jq_ajax_promise.done(function (data, textStatus, jqXHR) {
			result.success = true;
			result.data = data;
		})
		.fail(function (jqXHR, textStatus) {
			result.success = false;
			result.data = textStatus;
		});

		return result;
	};

	var xeracalm_optin_struct = function xeracalm_optin_struct() {
		this.struct = {
			action: "", //unsubscribe / subscribe
			uid: ""
		};

		this.setAction = function (v) {
			this.struct.action = v;
		};
		this.setUid = function (v) {
			this.struct.uid = v;
		};

		this.getData = function () {
			return this.struct;
		};
	}

	var remote_connection_struct = function remote_connection_struct() {
		this.struct = {
			username: "",
			password: ""
		};

		this.setUsername = function (v) {
			this.struct.username = v;
		};
		this.setPassword = function (v) {
			this.struct.password = v;
		};

		this.getData = function () {
			return this.struct;
		};
	}

	var register_account_struct = function register_account_struct() {
		this.struct = {
			name: "",
			mail: "",
			pass: "",
			field_birthday: {
				und: [{
					value: {
						month: "2",
						year: "1988",
						day: "23",
						hour: "0",
						minute: "0",
						second: "0"
					}
				}]
			},
			field_gender: {
				und: "1"
			},
			field_first_name: {
				und: [{
					value: "Firstname"
				}]
			},
			field_last_name: {
				und: [{
					value: "Lastname"
				}]
			},
			field_mobile_phone: {
				und: [{
					value: ""
				}]
			},
			field_user_country: {
				und: "123"
			},
			field_optin_xeracalm: {
				und: 0
			},
			field_optin_avene: {
				und: 0
			},
			field_legal: {
				und: 0
			}
		};

		this.setName = function (v) {
			this.struct.name = v;
		}
		this.setMail = function (v) {
			this.struct.mail = v;
		}
		this.setPass = function (v) {
			this.struct.pass = v;
		}
		//0 Monsieur / 1 Madame
		this.setGender = function (v) {
			this.struct.field_gender.und = v;
		};
		this.setFirstname = function (v) {
			this.struct.field_first_name.und[0].value = v;
		};
		this.setLastname = function (v) {
			this.struct.field_last_name.und[0].value = v;
		};
		this.setAddress = function (v) {
			this.struct.field_address.und[0].value = v;
		}
		this.setAddress2 = function (v) {
			this.struct.field_address_2.und[0].value = v;
		}
		this.setCity = function (v) {
			this.struct.field_city.und[0].value = v;
		}
		this.setZipcode = function (v) {
			this.struct.field_zip_code.und[0].value = v;
		}
		this.setMobilephone = function (v) {
			this.struct.field_mobile_phone.und[0].value = v;
		}
		this.setCountry = function (v) {
			this.struct.field_user_country.und = v;
		};
		this.setOptinXera = function (v) {
			this.struct.field_optin_xeracalm.und = v;
		}
		this.setOptinLegal = function (v) {
			this.struct.field_legal.und = v;
		}
		this.setOptinAvene = function(v){
			this.struct.field_optin_avene = v;
		}
		this.setBirthdayDate = function (day, month, year) {
			this.struct.field_birthday.und[0].value.day = day;
			this.struct.field_birthday.und[0].value.month = month;
			this.struct.field_birthday.und[0].value.year = year;

		};
		this.getData = function () {
			return this.struct;
		};
	};

	var post_comment_struct = function post_comment_struct() {
		this.struct = {
			uid: "0",
			nid: _getNid(),
			subject: "Comment Subject Text",
			status: "0",
			comment_body: {
				und: [{
					value: "Comment body text"
				}]
			}
		};

		this.setSubject = function (v) {
			this.struct.subject = v;
		}
		this.setBody = function (v) {
			this.struct.comment_body.und[0].value = v;
		}
		this.setNid = function (nid) {
			this.struct.nid = nid;
		}
		this.setUid = function (uid) {
			this.struct.uid = uid;
		}
		this.getData = function () {
			return this.struct;
		};
	};

	var get_comment_struct = function get_comment_struct() {
		this.struct = {
			nid: _getNid(),
			page: 0,
			range: 10
		};

		this.setNid = function (nid) {
			this.struct.nid = nid;
		}
		this.setPage = function (page) {
			this.struct.page = page;
		}
		this.setRange = function ( how_many ){
			this.struct.range = how_many;
		}
		this.getData = function () {
			return this.struct;
		};
	}


	// Extrait le nodeid du DOM de la page courante
	var _getNid = function _getNid() {
		var link = $("link[rel=shortlink]");
		if (0 == link.length) {
			return false;
		}

		var href = link.first().attr("href");

		return +(href.split("/").reverse()[0]);
	}

	var _issueRequest = function _issueRequest(url, data, async) {
		var headers = {};
		var the_async = async || false;

		if (xsrf_token) {
			headers["X-CSRF-TOKEN"] = xsrf_token;
		}

		return $.ajax(
			url,
			{
				async: the_async,
				method: "POST",
				headers: headers,
				contentType: "application/json",
				dataType: "json",
				processData: false,
				data: JSON.stringify(data)
			}
		);
	}


	// Expose public API
	return {
		remote_connection: remote_connection,
		register_account: register_account,
		post_comment: post_comment,
		get_comments: get_comments,
		xeracalm_optin: xeracalm_optin,
		is_logged_in: is_logged_in,


		get_remote_connection_struct: function () { return new remote_connection_struct() },
		get_register_account_struct: function () { return new register_account_struct() },
		get_post_comment_struct: function () { return new post_comment_struct() },
		get_get_comment_struct: function () { return new get_comment_struct() },
		get_xeracalm_optin_struct: function () { return new xeracalm_optin_struct() }
	};
})(jQuery);
